package it.uniroma1.dis.mfis.redia.verifint.model._dataTypes;



public class Visibility {
	public static final String PRIVATE = "private";

	public static final String PUBLIC = "public";

	public static final String PROTECTED = "protected";
	
	public static final String INCORRECT_VISIBILITY_VALUE_EXCEPTION = 
		"Visibility must be a String equals to \"public\" or \"protected\" or \"private\"";
	
	private String visibilityValue;
	
	protected Visibility() {
		super();
	}
	
	public Visibility(String s) {
		super();
		this.setVisibilityValue(s);
	}

	public String getVisibilityValue() {
		return visibilityValue;
	}
	
	private void setVisibilityValue(String visibilityValue) {
		if ((visibilityValue.equals(this.PUBLIC)) || (visibilityValue.equals(this.PRIVATE)) || (visibilityValue.equals(this.PROTECTED)))
			this.visibilityValue = visibilityValue;
		else
			throw new IllegalArgumentException(INCORRECT_VISIBILITY_VALUE_EXCEPTION);
	}
	
	
	@Override
	public boolean equals(Object o) {
		if (!(o instanceof Visibility))
			return false;
		Visibility m = (Visibility)o;
		return
			this.getVisibilityValue().equals(m.getVisibilityValue());
	}

	@Override
	public String toString() {
		return visibilityValue;
	}

	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}