package it.uniroma1.dis.mfis.redia.verifint.model.analysis.conceptualSpecifications;

import java.util.SortedSet;
import java.util.TreeSet;

import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.conceptualSpecifications._links.*;
import it.uniroma1.dis.mfis.redia.verifint.model._links.*;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams.CCDClass;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.realizativeSpecifications.RSClass;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis._links.*;

public class CSClass extends CSSpecification {
	
	private CCDClass ccdClass;
	private RSClass rsClass;
	
	protected CSClass() {
		super();
	}
	
	CSClass(String name) {
		super(name);
		
	}

	public void setCCDClass(CCDClass_hasConceptualClassSpecification_CSClass link)
	throws AssociationTargetException {
		if (!link.getCSClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.ccdClass = link.getCCDClass();
	}
	
	
	public void unsetCCDClass(CCDClass_hasConceptualClassSpecification_CSClass link)
	throws AssociationTargetException {
		if (!link.getCSClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.ccdClass = null;
	}

	public void setRSClass(CSClass_hasRealizativeClassSpecification_RSClass link)
	throws AssociationTargetException {
		if (!link.getCSClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rsClass = link.getRSClass();
	}

	public void unsetRSClass(CSClass_hasRealizativeClassSpecification_RSClass link)
	throws AssociationTargetException {
		if (!link.getCSClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rsClass = null;
	}
	
	public CCDClass getCCDClass() {
		return ccdClass;
	}
	private RSClass getRSClass() {
		return rsClass;
	}

}