package it.uniroma1.dis.mfis.redia.verifint.model.analysis.conceptualSpecifications;


import it.uniroma1.dis.mfis.redia.verifint.model.analysis.conceptualSpecifications._links.*;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis._links.*;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.classDiagrams.CCDOperation;
import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.utilities.Formula;

import java.util.Set;
import java.util.TreeSet;
import java.util.SortedSet;

public class CSOperation {

	private CSSpecification concSpec;
	private CCDOperation operation;
	private Set<Formula> post; 
	private Set<Formula> pre; 
	
	public CSOperation() {
	}
	

	public CCDOperation getClassOperation(){
		return operation;
	}
	
	protected void setClassOperation(CCDOperation op) { operation = op; }
	
	public void setClassOperation(CCDOperation_hasConcOpSpec_CSOperation link)
	throws AssociationTargetException {
		if (!link.getConceptualOpSpec().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setClassOperation(link.getClassOperation());
	}
	
	public void unsetClassOperation(CCDOperation_hasConcOpSpec_CSOperation link)
	throws AssociationTargetException {
		if (!link.getConceptualOpSpec().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.operation = null;
	}
	
	public CSSpecification getCSspecification() {
		return this.concSpec;
	}

	protected void setCSSpecification(CSSpecification cs) {
		this.concSpec = cs;
	}

	public void setCSSpecification(CSSpecification_hasOperationSpecification_CSOperation link)
	throws AssociationTargetException {
		if (!link.getOperationSpec().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.concSpec = link.getConcSpec();
	}

	public void unsetCSSpecification(CSSpecification_hasOperationSpecification_CSOperation link)
	throws AssociationTargetException {
		if (!link.getOperationSpec().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.concSpec = null;
	}
	
	public SortedSet<Formula> getPrecondition() {
		return new TreeSet<Formula>(this.pre);
	}
	protected void setPrecondition(Set<Formula> precondition) {
		pre = precondition;
	}
	
	public void addPrecondition(CSOperation_hasPrecondition_Formula link)
	throws AssociationTargetException {
		if (!link.getOperationSpec().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		pre.add(link.getPrecondition());
	}
	
	public void removePrecondition(CSOperation_hasPrecondition_Formula link)
	throws AssociationTargetException {
		if (!link.getOperationSpec().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		pre.remove(link.getPrecondition());
	}
	
	protected void setPostcondition(Set<Formula> postcondition) {
		post = postcondition;
	}
	
	public void addPostcondition(CSOperation_hasPostcondition_Formula link)
	throws AssociationTargetException {
		if (!link.getOperationSpec().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		post.add(link.getPostcondition());
	}
	
	public void removePostcondition(CSOperation_hasPostcondition_Formula link)
	throws AssociationTargetException {
		if (!link.getOperationSpec().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		post.remove(link.getPostcondition());
	}
	
	public CSSpecification getCSSpecification() {
		return concSpec;
	}
	public SortedSet<Formula> getPostcondition() {
		return new TreeSet<Formula>(this.post);
	}
}