package it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.types._interfaces.RTType;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.types._interfaces.RTTypeDefined;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.types._links.RTType_isTypeOf_RTTypeDefined;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.realizativeSpecifications.RSClass;
import it.uniroma1.dis.mfis.redia.verifint.model.realization._links.RCDClass_hasRealizativeClassSpecification_RSClass;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.types._interfaces.RTTypeDefined;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams._links.RCDClass_hasOperation_RCDClassOperation;
import java.util.SortedSet;
import java.util.TreeSet;
import java.util.Set;

public class RCDClass implements RTType {
	
	private String name;
	private RSClass rsClass;
	private SortedSet<RTTypeDefined> definedElements;
	private SortedSet<RCDClassOperation> rcdClassOperations;
	
	RCDClass(String name) {
		this.name = name;
	}
	
	public String getName() {
		return name;
	}

	public RSClass getRsClass() {
		return rsClass;
	}
	
	public void setRSClass(RCDClass_hasRealizativeClassSpecification_RSClass link)
	throws AssociationTargetException {
		if (!link.getRCDClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rsClass = link.getRSClass();
	}
	
	
	public void unsetRSClass(RCDClass_hasRealizativeClassSpecification_RSClass link)
	throws AssociationTargetException {
		if (!link.getRCDClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rsClass = null;
	}
	
	public SortedSet<RTTypeDefined> getDefinedElements() {
		return new TreeSet<RTTypeDefined>(definedElements);
	}
	
	public void addTypeDefinedElement(RTType_isTypeOf_RTTypeDefined link) throws AssociationTargetException {
		if (!link.getType().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.definedElements.add(link.getTypeDefined());
		
	}

	public void removeTypeDefinedElement(RTType_isTypeOf_RTTypeDefined link) throws AssociationTargetException {
		if (!link.getType().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.definedElements.remove(link.getTypeDefined());
		
	}
	
	public SortedSet<RCDClassOperation> getRcdClassOperations() {
		return new TreeSet<RCDClassOperation>(rcdClassOperations);
	}
	
	public void addRcdClassOperation(RCDClass_hasOperation_RCDClassOperation link) throws AssociationTargetException {
		if (!link.getRcdClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rcdClassOperations.add(link.getRcdClassOperation());
		
	}

	public void removeRcdClassOperation(RCDClass_hasOperation_RCDClassOperation link) throws AssociationTargetException {
		if (!link.getRcdClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rcdClassOperations.remove(link.getRcdClassOperation());
		
	}
	

}