package it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams.RCDDefOperation;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams.RCDClass;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams._links.RCDClass_hasOperation_RCDClassOperation;
import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Multiplicity;
import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Visibility;

public class RCDClassOperation extends RCDDefOperation  {

	private RCDClass rcdClass;

	public RCDClassOperation(String name, Multiplicity multiplicity,Visibility visibility) {
		super(name, multiplicity,visibility);
	}

	RCDClassOperation(String name) {
		this(name, new Multiplicity(DEFAULT_MINIMUM_MULTIPLICITY,DEFAULT_MAXIMUM_MULTIPLICITY),
			new Visibility(Visibility.PUBLIC));
	}
	
	protected void setRcdClass(RCDClass rcdClass) { 
		this.rcdClass = rcdClass; 
	}
	
	public RCDClass getRcdClass(){
		return rcdClass;
	}
	
	public void setRcdClass(RCDClass_hasOperation_RCDClassOperation link)
	throws AssociationTargetException {
		if (!link.getRcdClassOperation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rcdClass = link.getRcdClass();
	}
	
	public void unsetRcdClass(RCDClass_hasOperation_RCDClassOperation link)
	throws AssociationTargetException {
		if (!link.getRcdClassOperation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rcdClass = null;
	}

}