package it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model.realization.types._interfaces.RTType;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.types._interfaces.RTTypeDefined;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.types._links.RTType_isTypeOf_RTTypeDefined;
import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams._links.RCDDataStructure_hasOperation_RCDDataStructureOperation;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.realizativeSpecifications.RSDataStructure;
import it.uniroma1.dis.mfis.redia.verifint.model.realization._links.RCDDataStructure_hasDataStructureSpecification_RSDataStructure;

import java.util.SortedSet;
import java.util.TreeSet;


public class RCDDataStructure implements RTType {
	
	private String name;
	private SortedSet<RTTypeDefined> definedElements;
	private SortedSet<RCDDataStructureOperation> rcdDataStructureOperation;
	private RSDataStructure rsDataStructure;
	
	
	private boolean sideEffect;
	private boolean sharedMemory;
	private boolean deepEquality;
	
	
	public RCDDataStructure(String name) {
		this.name = name;
		definedElements = new TreeSet<RTTypeDefined>();
		sideEffect = false;
		sharedMemory = false;
		deepEquality = false;
	}
	public RCDDataStructure(String name,boolean sideEffect,boolean sharedMemory,boolean deepEquality) {
		this.name = name;
		this.sideEffect = sideEffect;
		this.sharedMemory = sharedMemory;
		this.deepEquality = deepEquality;
		definedElements = new TreeSet<RTTypeDefined>();
	}
	
	public String getName() {
		return name;
	}
	
	public boolean getSideEffect() {
		return sideEffect;
	}
	
	public void setSideEffect(boolean sideEffect) {
		this.sideEffect = sideEffect;
	}
	
	public boolean getSharedMemory() {
		return sharedMemory;
	}
	
	public void setSharedMemmory(boolean sharedMemory) {
		this.sharedMemory = sharedMemory;
	}
	
	public boolean getDeepEquality() {
		return deepEquality;
	}
	
	public void setDeepEquality(boolean deepEquality) {
		this.deepEquality = deepEquality;
	}
	
	public SortedSet<RTTypeDefined> getDefinedElements() {
		return new TreeSet<RTTypeDefined>(definedElements);
	}
	
	protected void setDefinedElements(SortedSet<RTTypeDefined> definedElements) {
		this.definedElements = definedElements;
	}
	
	public void addTypeDefinedElement(RTType_isTypeOf_RTTypeDefined link) throws AssociationTargetException {
		if (!link.getType().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.definedElements.add(link.getTypeDefined());
		
	}

	public void removeTypeDefinedElement(RTType_isTypeOf_RTTypeDefined link) throws AssociationTargetException {
		if (!link.getType().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.definedElements.remove(link.getTypeDefined());
		
	}
	
	public SortedSet<RCDDataStructureOperation> getRcdDataStructureOperation() {
		return new TreeSet<RCDDataStructureOperation>(rcdDataStructureOperation);
	}
	
	protected void setRcdDataStructureOperation(SortedSet<RCDDataStructureOperation> rcdDataStructureOperation) {
		this.rcdDataStructureOperation = rcdDataStructureOperation;
	}
	
	public RSDataStructure getRsDataStructure(){
		return rsDataStructure;
	}
	
	public void addRcdDataStructureOperation(RCDDataStructure_hasOperation_RCDDataStructureOperation link) throws AssociationTargetException {
		if (!link.getRcdDataStructure().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rcdDataStructureOperation.add(link.getRcdDataStructureOperation());
		
	}

	public void removeRcdDataStructureOperation(RCDDataStructure_hasOperation_RCDDataStructureOperation link) throws AssociationTargetException {
		if (!link.getRcdDataStructure().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rcdDataStructureOperation.remove(link.getRcdDataStructureOperation());
		
	}
	
	
	public void setRsDataStructure(RCDDataStructure_hasDataStructureSpecification_RSDataStructure link)
	throws AssociationTargetException {
		if (!link.getRCDDataStructure().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rsDataStructure = link.getRSDataStructure();
	}
	
	public void unsetRsDataStructure(RCDDataStructure_hasDataStructureSpecification_RSDataStructure link)
	throws AssociationTargetException {
		if (!link.getRCDDataStructure().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rsDataStructure = null;
	}

	

}