package it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams.RCDDefOperation;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams.RCDDataStructure;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams._links.RCDDataStructure_hasOperation_RCDDataStructureOperation;
import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Multiplicity;
import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Visibility;

public class RCDDataStructureOperation extends RCDDefOperation  {

	private RCDDataStructure rcdDataStructure;

	public RCDDataStructureOperation(String name, Multiplicity multiplicity,Visibility visibility) {
		super(name, multiplicity,visibility);
	}

	RCDDataStructureOperation(String name) {
		this(name, new Multiplicity(DEFAULT_MINIMUM_MULTIPLICITY,DEFAULT_MAXIMUM_MULTIPLICITY),
			new Visibility(Visibility.PUBLIC));
	}
	
	protected void setRcdDataStructure(RCDDataStructure rcdDataStructure) { 
		this.rcdDataStructure = rcdDataStructure; 
	}
	
	public RCDDataStructure getRcdDataStructure(){
		return rcdDataStructure;
	}
	
	public void setRcdDataStructure(RCDDataStructure_hasOperation_RCDDataStructureOperation link)
	throws AssociationTargetException {
		if (!link.getRcdDataStructureOperation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rcdDataStructure = link.getRcdDataStructure();
	}
	
	public void unsetRcdDataStructure(RCDDataStructure_hasOperation_RCDDataStructureOperation link)
	throws AssociationTargetException {
		if (!link.getRcdDataStructureOperation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rcdDataStructure = null;
	}
}

