package it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model.realization.realizativeSpecifications.RSOperation;
import it.uniroma1.dis.mfis.redia.verifint.model.realization._links.RCDDefOperation_hasRealizativeOperationSpecification_RSOperation;
import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Multiplicity;
import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Visibility;
import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;

import java.util.ArrayList;

public abstract class RCDDefOperation extends RCDOperation {
	
	private RSOperation realizativeSpecification;

	RCDDefOperation(String name, Multiplicity multiplicity,Visibility visibility) {
		super(name, multiplicity,visibility);
		this.inputParameters = new ArrayList<RCDParameter>();
	}

	RCDDefOperation(String name) {
		this(name, new Multiplicity(DEFAULT_MINIMUM_MULTIPLICITY,DEFAULT_MAXIMUM_MULTIPLICITY),
			new Visibility(Visibility.PUBLIC));
	}
	
	protected RCDDefOperation() {
		super();
	}

	public RSOperation getRealizativeOperationSpecification(){
		return realizativeSpecification;
	}
	
	protected void setRealizativeOperationSpecification(RSOperation rsOp) { 
		realizativeSpecification = rsOp; 
	}
	
	public void setRealizativeOperationSpecification(RCDDefOperation_hasRealizativeOperationSpecification_RSOperation link)
	throws AssociationTargetException {
		if (!link.getRealDefOperation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setRealizativeOperationSpecification(link.getRealizativeOpSpec());
	}
	
	public void unsetRealizativeOperationSpecification(RCDDefOperation_hasRealizativeOperationSpecification_RSOperation link)
	throws AssociationTargetException {
		if (!link.getRealDefOperation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.realizativeSpecification = null;
	}

}