package it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams;

import java.io.Serializable;
import java.util.List;
import java.util.SortedSet;
import java.util.TreeSet;

import it.uniroma1.dis.mfis.redia.verifint.model.Diagram;
import it.uniroma1.dis.mfis.redia.verifint.model._interfaces.Identifiable;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams._links.RCDDiagram_isComposedBy_RCDElement;

public class RCDDiagram implements Diagram,	Comparable<RCDDiagram>,	Serializable {

	private String name;
	
	private SortedSet<RCDElement> elements;

	protected RCDDiagram() {}
	
	public RCDDiagram(String name) {
		this.name = name;
		this.elements = new TreeSet<RCDElement>(); 
	}

	public void addElement(RCDDiagram_isComposedBy_RCDElement cRDDiagram_isComposedBy_RCDElement) {
		this.elements.add(cRDDiagram_isComposedBy_RCDElement.getElement());
	}

	public void removeElement(RCDDiagram_isComposedBy_RCDElement cRDDiagram_isComposedBy_RCDElement) {
		this.elements.remove(cRDDiagram_isComposedBy_RCDElement.getElement());
	}

	protected void setElements(SortedSet<RCDElement> elements) {
		this.elements = elements;
	}

	public int compareTo(RCDDiagram o) {
		return this.name.compareTo(o.getName());
	}

	
	public boolean equals(Object obj) {
		if (obj instanceof RCDDiagram) {
			RCDDiagram o = (RCDDiagram) obj;
			return this.name.equals(o.getName());			
		}
		return false;
	}
	
	public SortedSet<Identifiable> getElements() { 
		return new TreeSet<Identifiable>(this.elements);
	}

	public String getName() { return this.name; }

	public void setName(String name) { this.name = name; }
	
}