package it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams;


import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams._links.RCDOperation_hasParameter_RCDParameter;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.operations._interfaces.ROpOperation;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.operations._interfaces.ROpParameter;
import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Visibility;
import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Multiplicity;

import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;

import it.uniroma1.dis.mfis.redia.verifint.model.realization.types._interfaces.RTType;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.types._links.RTType_isTypeOf_RTTypeDefined;

import java.util.List;
import java.util.ArrayList;

public abstract class RCDOperation extends RCDProperty implements ROpOperation {
	
	
	private Visibility visibility;
	protected List<RCDParameter> inputParameters;
	
	
	RCDOperation(String name, Multiplicity multiplicity,Visibility visibility) {
		super(name, multiplicity);
		this.inputParameters = new ArrayList<RCDParameter>();
		this.visibility = visibility;
	}
	
	protected RCDOperation() {
		super();
	}
	
	public List<ROpParameter> getInputParameters() {
		return new ArrayList<ROpParameter>(this.inputParameters);
	}

	protected void setInputParameters(List<RCDParameter> inputParameters) {
		this.inputParameters = inputParameters;
	}

	public void addInputParameter(RCDOperation_hasParameter_RCDParameter link)
	throws AssociationTargetException {
		if (!link.getOperation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.inputParameters.add(link.getParameter());
	}

	public void removeInputParameter(RCDOperation_hasParameter_RCDParameter link)
	throws AssociationTargetException {
		if (!link.getOperation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.inputParameters.remove(link.getParameter());
	}
	
	
	public RTType getReturnType() {
		return super.getType();
	}

	protected void setReturnType(RTType returnType) {
		super.setType(returnType);
	}
	


	public void setType(RTType_isTypeOf_RTTypeDefined link)
	throws AssociationTargetException {
		if (!link.getTypeDefined().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setReturnType(link.getType());
	}
	

	public void setReturnType(RTType_isTypeOf_RTTypeDefined link)
	throws AssociationTargetException {
		this.setType(link);
	}
	
	public Visibility getVisibility() {
		return visibility;
	}
	public void setVisibility(Visibility visibility) {
		this.visibility = visibility;
	}
	



}