package it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model._dataTypes.Multiplicity;
import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams._links.RCDOperation_hasParameter_RCDParameter;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.operations._interfaces.ROpOperation;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.operations._interfaces.ROpParameter;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.types._interfaces.RTType;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.types._links.RTType_isTypeOf_RTTypeDefined;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.types._interfaces.RTType;

public class RCDParameter extends RCDInnerComponent
implements ROpParameter {

	public static final Short DEFAULT_MINIMUM_MULTIPLICITY = 0;
	public static final Short DEFAULT_MAXIMUM_MULTIPLICITY = 1;

	private RTType type;
	private Multiplicity multiplicity;
	private RCDOperation ownerOperation;

	RCDParameter(String name, RTType type, Multiplicity multiplicity) {
		super(name, multiplicity);
		this.type = type;
	}

	RCDParameter(String name, RTType type) {
		this(name, type,new Multiplicity(DEFAULT_MINIMUM_MULTIPLICITY,DEFAULT_MAXIMUM_MULTIPLICITY));
	}
	
	protected RCDParameter() {
		super();
	}

	public RTType getType() {
		return this.type;
	}

	protected void setType(RTType type) {
		this.type = type;
	}

	public void setType(RTType_isTypeOf_RTTypeDefined link)
	throws AssociationTargetException {
		if (!link.getTypeDefined().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setType(link.getType());
	}

	public Multiplicity getMultiplicity() {
		return multiplicity;
	}

	public void setMultiplicity(Multiplicity multiplicity) {
		this.multiplicity = multiplicity;
	}

	public ROpOperation getOwnerOperation() {
		return ownerOperation;
	}

	protected void setOwnerOperation(RCDOperation ownerOperation) {
		this.ownerOperation = ownerOperation;
	}

	public void setOwnerOperation(RCDOperation_hasParameter_RCDParameter link)
	throws AssociationTargetException {
		if (!link.getParameter().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setOwnerOperation(link.getOperation());
	}

	public void unsetOwnerOperation(RCDOperation_hasParameter_RCDParameter link)
	throws AssociationTargetException {
		if (!link.getParameter().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.ownerOperation = null;
	}
	
}