package it.uniroma1.dis.mfis.redia.verifint.model.realization.realizativeSpecifications;

import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model._links.CSClass_hasRealizativeClassSpecification_RSClass;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams.RCDClass;
import it.uniroma1.dis.mfis.redia.verifint.model.realization._links.RCDClass_hasRealizativeClassSpecification_RSClass;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.conceptualSpecifications.CSClass;

public class RSClass extends RSSpecification {
	
	private RCDClass rcdClass;
	private CSClass csClass;
	
	protected RSClass() {
		super();
	}
	
	RSClass(String name) {
		super(name);	
	}

	public void setRCDClass(RCDClass_hasRealizativeClassSpecification_RSClass link)
	throws AssociationTargetException {
		if (!link.getRSClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rcdClass = link.getRCDClass();
	}
	
	
	public void unsetRCDClass(RCDClass_hasRealizativeClassSpecification_RSClass link)
	throws AssociationTargetException {
		if (!link.getRSClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rcdClass = null;
	}

	public void setCSClass(CSClass_hasRealizativeClassSpecification_RSClass link)
	throws AssociationTargetException {
		if (!link.getRSClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.csClass = link.getCSClass();
	}

	public void unsetCSClass(CSClass_hasRealizativeClassSpecification_RSClass link)
	throws AssociationTargetException {
		if (!link.getRSClass().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.csClass = null;
	}
	public RCDClass getRCDClass() {
		return rcdClass;
	}
	public CSClass getCSClass() {
		return csClass;
	}

}