package it.uniroma1.dis.mfis.redia.verifint.model.realization.realizativeSpecifications;

import it.uniroma1.dis.mfis.redia.verifint.model.realization.realizativeSpecifications._links.*;
import it.uniroma1.dis.mfis.redia.verifint.model.realization._links.*;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams.RCDOperation;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams.RCDDefOperation;
import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.utilities.*;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.utilities.OperationAlgorithm;
import it.uniroma1.dis.mfis.redia.verifint.model.realization._links.RSOperation_hasAlgorithm_OperationAlgorithm;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.utilities.OperationPrecondition;


import java.util.Set;

public class RSOperation {

	private RSSpecification rsSpecification;
	private RCDDefOperation rcdDefOperation;
	private OperationAlgorithm operationAlgorithm; 
	private OperationPrecondition operationPrecondition;
	
	public RSOperation() {
	}
	
	public RCDDefOperation getRcdDefOperation(){
		return rcdDefOperation;
	}
	
	protected void setRcdDefOperation(RCDDefOperation rcdDefOperation) { 
		this.rcdDefOperation = rcdDefOperation; 
	}
	
	public void setRcdDefOperation(RCDDefOperation_hasRealizativeOperationSpecification_RSOperation link)
	throws AssociationTargetException {
		if (!link.getRealizativeOpSpec().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.setRcdDefOperation(link.getRealDefOperation());
	}
	
	public void unsetRcdDefOperation(RCDDefOperation_hasRealizativeOperationSpecification_RSOperation link)
	throws AssociationTargetException {
		if (!link.getRealizativeOpSpec().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rcdDefOperation = null;
	}
	
	public RSSpecification getRSSpecification() {
		return this.rsSpecification;
	}

	protected void setRSSpecification(RSSpecification rsSpecification) {
		this.rsSpecification = rsSpecification;
	}

	public void setRSSpecification(RSSpecification_hasOperationSpecification_RSOperation link)
	throws AssociationTargetException {
		if (!link.getRSOperation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rsSpecification = link.getRSSpecification();
	}

	public void unsetRSSpecification(RSSpecification_hasOperationSpecification_RSOperation link)
	throws AssociationTargetException {
		if (!link.getRSOperation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.rsSpecification = null;
	}
	
	public OperationPrecondition getOperationPrecondition() {
		return operationPrecondition;
	}
	protected void seOperationtPrecondition(OperationPrecondition OperationPrecondition) {
		this.operationPrecondition = operationPrecondition;
	}
	
	public void setOperationPrecondition(RSOperation_hasPrecondition_OperationPrecondition link)
	throws AssociationTargetException {
		if (!link.getRsOperation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		operationPrecondition = link.getOperationPrecondition();
	}
	
	public void unsetOperationPrecondition(RSOperation_hasPrecondition_OperationPrecondition link)
	throws AssociationTargetException {
		if (!link.getRsOperation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		operationPrecondition = null;
	}
	
	protected void setOperationAlgorithm(OperationAlgorithm operationAlgorithm) {
		this.operationAlgorithm = operationAlgorithm;
	}
	
	public void setOperationAlgorithm(RSOperation_hasAlgorithm_OperationAlgorithm link)
	throws AssociationTargetException {
		if (!link.getRsOperation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.operationAlgorithm = link.getOperationAlgorithm();
	}
	
	public void unsetOperationAlgorithm(RSOperation_hasAlgorithm_OperationAlgorithm link)
	throws AssociationTargetException {
		if (!link.getRsOperation().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.operationAlgorithm = null;
	}
	public OperationAlgorithm getOperationAlgorithm() {
		return operationAlgorithm;
	}
	
}