package it.uniroma1.dis.mfis.redia.verifint.model.realization.types;

import it.uniroma1.dis.mfis.redia.verifint.model.realization.types._links.RTType_isTypeOf_RTTypeDefined;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.types._interfaces.RTTypeDefined;
import it.uniroma1.dis.mfis.redia.verifint.model._exceptions.AssociationTargetException;

import java.util.SortedSet;
import java.util.TreeSet;

public class RTBaseType extends RTLanguageType {
	
	private String name;
	private SortedSet<RTTypeDefined> definedElements;
	
	public RTBaseType(String name) {
		this.name = name;
		this.definedElements = new TreeSet<RTTypeDefined>();
	}
	
	public String getName() {
		return name;	
	}
	
	public SortedSet<RTTypeDefined> getDefinedElements() {
		return new TreeSet<RTTypeDefined>(definedElements);
	}
	
	protected void setDefinedElements(SortedSet<RTTypeDefined> definedElements) {
		this.definedElements = definedElements;
	}

	public void addTypeDefinedElement(RTType_isTypeOf_RTTypeDefined link) throws AssociationTargetException {
		if (!link.getType().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.definedElements.add(link.getTypeDefined());
		
	}

	public void removeTypeDefinedElement(RTType_isTypeOf_RTTypeDefined link) throws AssociationTargetException {
		if (!link.getType().equals(this))
			throw new AssociationTargetException(
					link.getClass().getName(),
					this.getClass().getName());
		this.definedElements.remove(link.getTypeDefined());
		
	}
	
}