package it.uniroma1.dis.mfis.redia.verifint.model.realization.utilities;

import it.uniroma1.dis.mfis.redia.verifint.model.realization.realizativeSpecifications.RSOperation;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams.RCDOperation;
import java.io.*;

public class AlgorithmJavaImplementation extends OperationAlgorithm {
	
	private String algorithm;
	
	//AlgorithmJavaImplementation (extends)-> OperationAlgorithm -> RSOperation -> RCDOperation (extends) -> getName()
	
	public AlgorithmJavaImplementation(String algorithm) {	
		this.algorithm = algorithm;
		saveAlgorithm();
	}
	
	public AlgorithmJavaImplementation() {
		this.algorithm = "";
		saveAlgorithm();
	}
	
	private void saveAlgorithm() {
		
		RSOperation rsOperation = this.getRsOperation();
		RCDOperation rcdDefOperation = rsOperation.getRcdDefOperation();
		String operationName = rcdDefOperation.getName();
		
		try {
		    FileWriter fw =new FileWriter(operationName);
		    BufferedWriter bw =new BufferedWriter(fw);
    		
    		bw.write(algorithm+"\n");	 		
			bw.close();
			fw.close();
		}
		catch(FileNotFoundException fnfe) { System.out.println("File not found "+fnfe.getMessage());}
		catch(IOException ioe) { System.out.println("IO Error "+ioe.getMessage()); }			
	}
	
}