package it.uniroma1.dis.mfis.redia.verifint.model.realization.utilities;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.utilities.FormulaFOL;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.realizativeSpecifications.RSOperation;
import it.uniroma1.dis.mfis.redia.verifint.model.realization.classDiagrams.RCDOperation;
import java.io.*;

public class JASSPrecondition extends OperationPrecondition {
	
	private String formulaJass;
	
	public JASSPrecondition(){
	}
	
	public JASSPrecondition(String formulaJass) {
		this.formulaJass = formulaJass;
		savePrecondition();
	}
	
	public String getJASSPrecondition() {
		return formulaJass;
	}
	public void setJASSPrecondition(String formulaJass) {
		this.formulaJass = formulaJass;
	}

	
	private void savePrecondition() {
		
		RSOperation rsOperation = this.getRsOperation();
		RCDOperation rcdDefOperation = rsOperation.getRcdDefOperation();
		String operationName = rcdDefOperation.getName();
		
		try {
		    FileWriter fw =new FileWriter(operationName+".txt");
		    BufferedWriter bw =new BufferedWriter(fw);
    		
    		bw.write(formulaJass+"\n");	 		
			bw.close();
			fw.close();
		}
		catch(FileNotFoundException fnfe) { System.out.println("File not found "+fnfe.getMessage());}
		catch(IOException ioe) { System.out.println("IO Error "+ioe.getMessage()); }			
	}
}