package it.uniroma1.dis.mfis.redia.verifint.test;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.utilities.ocl.*;


import java.io.FileWriter;
import java.io.FileReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.util.StringTokenizer;
import java.util.Vector;
import java.io.*;
   
public class Ocl2Jass {

		   public static FileWriter fw ;
		   public static BufferedWriter bw;		
  		
		 
  public static void toJass(File oclFile,File jassFile,boolean addStartRequire,boolean addEndRequire) throws IOException{    

    try {      

      	fw =new FileWriter(jassFile,true);
      	bw =new BufferedWriter(fw);
      	if(addStartRequire)
      		bw.write("/** require ");
      	
      	if(addEndRequire){
      		bw.write("\n **/");
      		bw.close();
      		fw.close();
      		return;
      	}
      	      		
      	bw.write("\n");
      	
      	Lexer lexer = new Lexer(new java.io.FileInputStream(oclFile));
      	
      	parser p = new parser(lexer);
     	Object res = p.parse().value;
      	
      	if(res instanceof Vector){
      		Vector v = (Vector) p.parse().value;
      		OclExpression result1 = (OclExpression) v.elementAt(0);
      		visitTree(result1);
      		bw.write(" in ");
      		OclExpression result2 = (OclExpression) v.elementAt(1);
      		visitTree(result2);
      	}
      	else {
      		OclExpression result = (OclExpression)res;
      		visitTree(result);
    	}
    	
    	bw.write(";");
    	
      	bw.close();
      	fw.close();      
    } 
    catch (Exception e) {     
      e.printStackTrace();
    }
  }
 public static void visitTree(OclExpression e) throws IOException{
  	if(e instanceof OclBinaryExpression){
    	OclBinaryExpression binExpr = (OclBinaryExpression) e;
    	if(binExpr instanceof OclLogicalExpr | binExpr instanceof OclRelationalExpr | binExpr instanceof OclAdditiveExpr | binExpr instanceof OclMultExpr){
    		if(binExpr.getOperator().equals("implies")){
    			OclUnaryExpression unExpr = new OclUnaryExpression(binExpr.getLeftChild(),"not");
    			OclLogicalExpr implExpr = new OclLogicalExpr(binExpr.getRightChild(),unExpr,"or");
    			visitTree(implExpr);
    		}
    		else{
    			if(binExpr.getLeftChild().toString().equals("self")){
    				binExpr.setLeftChild(new OclName("this"));
    			}
    			if(binExpr.getRightChild().toString().equals("self")){
    				binExpr.setRightChild(new OclName("this"));
    			}
    			if(binExpr.getLeftChild().toString().equals("result")){
    				binExpr.setLeftChild(new OclName("Result"));
    			}
    			if(binExpr.getRightChild().toString().equals("result")){
    				binExpr.setRightChild(new OclName("Result"));
    			}
    			visitTree(binExpr.getLeftChild());
  				bw.write(getJassBinaryOperator(binExpr.getOperator()));
  				visitTree(binExpr.getRightChild());
  				
    		}
    	}
    	else if(binExpr instanceof OclDcolonExpr | binExpr instanceof OclPostFixExpr){
    		if(binExpr.getOperator().equals("::")){
    			visitTree(binExpr.getLeftChild());
  				bw.write(".");
  				visitTree(binExpr.getRightChild());
    		}
    		else if(binExpr.getOperator().equals(".")){
    			if(binExpr.getLeftChild().toString().equals("self")){
    				binExpr.setLeftChild(new OclName("this"));
    			}
    			if(binExpr.getRightChild().toString().equals("self")){
    				binExpr.setRightChild(new OclName("this"));
    			}
    			if(binExpr.getLeftChild().toString().equals("result")){
    				binExpr.setLeftChild(new OclName("Result"));
    			}
    			if(binExpr.getRightChild().toString().equals("result")){
    				binExpr.setRightChild(new OclName("Result"));
    			}
    			visitTree(binExpr.getLeftChild());
  				bw.write(".");
  				visitTree(binExpr.getRightChild());
    		}
    		else if(binExpr.getOperator().equals(":")){
    			visitTree(binExpr.getRightChild());
  				bw.write("  ");
  				visitTree(binExpr.getLeftChild());
    		}
    		else if(binExpr.getOperator().equals("->")){
    			OclPostFixExpr pFExpr = (OclPostFixExpr) binExpr;
    			OclPropCall propCall = (OclPropCall)pFExpr.getRightChild();


    			if(propCall.getSimpleTypeSpec().toString().equals("forAll")){
    				bw.write("(forall ");
    				visitTree(propCall.getPropCallParams().getDeclarator().getList());
    				bw.write(" : {0 .. ");
    				visitTree(pFExpr.getLeftChild());
    				bw.write(".length} # ");
    				String arr = pFExpr.getLeftChild().toString();
    				OclListExpr old_list = propCall.getPropCallParams().getList();    				   				
    				OclListExpr varList = propCall.getPropCallParams().getDeclarator().getList();    				    				
    				OclListExpr new_list = auxMethod(old_list,varList,arr);    				
    				visitTree(new_list); 
    				bw.write(")");   				
    			}
    		    else if(propCall.getSimpleTypeSpec().toString().equals("exists")){
    		    	bw.write("(exists ");
    		    	visitTree(propCall.getPropCallParams().getDeclarator().getList());
    				bw.write(" : {0 .. ");
    				visitTree(pFExpr.getLeftChild());
    				bw.write(".length} # ");
    				String arr = pFExpr.getLeftChild().toString();    				
    				OclListExpr old_list = propCall.getPropCallParams().getList();    				   				
    				OclListExpr varList = propCall.getPropCallParams().getDeclarator().getList();    				    				
    				OclListExpr new_list = auxMethod(old_list,varList,arr);    				
    				visitTree(new_list);
    				bw.write(")");
    		    }
    		    else if(propCall.getSimpleTypeSpec().toString().equals("size()")){
    		    	visitTree(binExpr.getLeftChild());
    		    	bw.write(".length");
    		    }
    		    else if(binExpr.getRightChild().toString().equals("size()")){
    		    	visitTree(binExpr.getLeftChild());
    		    	bw.write(".length");
    		    }
    		    else if(binExpr.getRightChild().toString().equals("isEmpty")){
    		    	visitTree(binExpr.getLeftChild());
    		    	bw.write(".isEmpty()");
    		    }
    		    else if(propCall.getSimpleTypeSpec().toString().equals(("includes"))){
    		    	bw.write("(exists i");
    				bw.write(" : {0 .. ");
    				visitTree(pFExpr.getLeftChild());
    				bw.write(".length} # ");    				
    				String var = propCall.getPropCallParams().getList().toString();
    				bw.write(var + " == ");
    				String arr = pFExpr.getLeftChild().toString();    				
    				OclListExpr old_list = propCall.getPropCallParams().getList();    				
    				OclListExpr new_list = auxMethod2(old_list,var,arr);    				
    				visitTree(new_list);
    				bw.write(")");    				
    			}
    			else if(propCall.getSimpleTypeSpec().toString().equals(("excludes"))){
    		    	bw.write("( ! exists i");
    				bw.write(" : {0 .. ");
    				visitTree(pFExpr.getLeftChild());
    				bw.write(".length} # ");    				
    				String var = propCall.getPropCallParams().getList().toString();
    				bw.write(var + " == ");
    				String arr = pFExpr.getLeftChild().toString();    				
    				OclListExpr old_list = propCall.getPropCallParams().getList();    				
    				OclListExpr new_list = auxMethod2(old_list,var,arr);    				
    				visitTree(new_list);
    				bw.write(")");    				
    			}
    		}
    	}
    	
    	else if(binExpr instanceof OclRangeExpr){
    	
    	}
 
  	}
  	else if(e instanceof OclUnaryExpression){
  		OclUnaryExpression unExpr = (OclUnaryExpression)e;
  		if(unExpr.getChild().toString().equals("result")){
    		unExpr.setChild(new OclName("Result"));
    	}
    	if(unExpr.getChild().toString().equals("self")){
    		unExpr.setChild(new OclName("this"));
    	}
  		if(unExpr.getUnaryOperator().equals("not")){
  			bw.write("!");
  		}
  		else if(unExpr.getUnaryOperator().equals("-")){
  			bw.write("-");
  		}
  		visitTree(unExpr.getChild());  		
  	}
  	else if(e instanceof OclIfExpr) {
  		OclIfExpr ifExpr = (OclIfExpr)e;
  		bw.write(" if ");
  		visitTree(ifExpr.getIfExpr());
  		bw.write(" then ");
  		visitTree(ifExpr.getThenExpr());
  		bw.write(" else ");
  		visitTree(ifExpr.getElseExpr());
  	}
  	else if(e instanceof OclLetExpr) {
  		OclLetExpr letExpr = (OclLetExpr)e;
  		bw.write("let ");
  		
  		if(letExpr.getTypeSpec() != null){
  			visitTree(letExpr.getTypeSpec());
  		}
  		bw.write(" ");
  		visitTree(letExpr.getName());
  		if(letExpr.getFormalParam() != null){
  			visitTree(letExpr.getFormalParam());
  		}
  		
  		bw.write(" = ");
  		visitTree(letExpr.getExpression());
  		
  	}
  	else if(e instanceof OclDeclarator) {
  		OclDeclarator declExpr = (OclDeclarator)e;
  		
  		if(declExpr.getSimpleTypeSpec()!= null){
   			bw.write(" : ");
  			visitTree(declExpr.getSimpleTypeSpec());
  		}
  		if(declExpr.getList() != null){
  			visitTree(declExpr.getList()); 			
  		}
   		
  		if(declExpr.getName()!=null){
  			bw.write(";");
  			visitTree(declExpr.getTypeSpec());  			
  			bw.write(":");
  			visitTree(declExpr.getName());
  			bw.write("=");
  			visitTree(declExpr.getExpr());
  			bw.write("|");
  		}
  		if(declExpr.getName()==null){
  			bw.write("|");
  		}
  		
  	}
  	else if(e instanceof OclListExpr){
  		OclListExpr listExpr = (OclListExpr) e;
  		bw.write(listExpr.getOpenBrack());
  		OclExpression [] express= listExpr.getCollection();
  			if(express.length == 1){
  				visitTree(express[0]);  				
  			}
  			else if(express.length > 0){
  				for(int i=0;i<express.length-1;i++){
  					visitTree(express[i]);
  					bw.write(listExpr.getSeparator());
  				}
  				visitTree(express[express.length-1]);
  			}  			
  		
  			bw.write(listExpr.getCloseBrack());		
  	}
  	else if (e instanceof OclCollTypeExpr){
  		OclCollTypeExpr collExpr = (OclCollTypeExpr)e;
  		bw.write(collExpr.getCollectionType());
  		visitTree(collExpr.getExpression());
  	}
  	else if (e instanceof OclLiteralCollectExpr){
  		bw.write("{");
   		OclLiteralCollectExpr collExpr = (OclLiteralCollectExpr)e;
  		OclExpression [] express= collExpr.getCollection();
  			if(express.length == 1){
  				visitTree(express[0]);  				
  			}
  			else if(express.length > 0){
  				for(int i=0;i<express.length-1;i++){
  					visitTree(express[i]);
  					bw.write(",");
  				}
  				visitTree(express[express.length-1]);
  			}  			
  		
  			bw.write("}");
  	}
  	else if (e instanceof OclPropCallParams){
  		OclPropCallParams params = (OclPropCallParams)e;
  		bw.write("(");
  		if(params.getDeclarator()!=null){
  			visitTree(params.getDeclarator());
  		}
  		visitTree(params.getList());
  		bw.write(")");
  	}
  	else if(e instanceof OclPropCall){
  		OclPropCall propCall = (OclPropCall)e;
  		if(propCall.getPre()){
  			bw.write("Old.");
  		}
  		visitTree(propCall.getSimpleTypeSpec());
  		
  		if(propCall.getQualifier() != null){
  			visitTree(propCall.getQualifier());
  		}
  		if(propCall.getPropCallParams()!=null){
  			visitTree(propCall.getPropCallParams());
  		}
  	}
  	else{
  		bw.write(e.toString());
  	}
  }
  private static String getJassBinaryOperator(String oclBinaryOperator){
  	if(oclBinaryOperator.equals("and")){
  		return " && ";
  	}
  	if(oclBinaryOperator.equals("or")){
  		return " || ";
  	}
  	if(oclBinaryOperator.equals("xor")){
  		return  " ^ ";
  	}
  	if(oclBinaryOperator.equals(">")){
  		return " > ";
  	}
  	if(oclBinaryOperator.equals("<")){
  		return " < ";
  	}
  	if(oclBinaryOperator.equals(">=")){
  		return " >= ";
  	}
  	if(oclBinaryOperator.equals("<=")){
  		return " <= ";
  	}
  	if(oclBinaryOperator.equals("=")){
  		return " == ";
  	}
  	if(oclBinaryOperator.equals("<>")){
  		return " != ";
  	}
  	if(oclBinaryOperator.equals("+")){
  		return " + ";
  	}if(oclBinaryOperator.equals("-")){
  		return " - ";
  	}if(oclBinaryOperator.equals("*")){
  		return " * ";
  	}if(oclBinaryOperator.equals("/")){
  		return " / ";
  	}

   return "";
  		  			
  }
    private static OclListExpr auxMethod(OclListExpr listExpr,OclListExpr varList,String arr){
  	
  	OclExpression[] list = listExpr.getCollection();
  	
  	OclExpression []vars = varList.getCollection();   	
  	
	for(int j=0;j<vars.length;j++){	
  		
  		for(int i=0;i<list.length;i++){
	  		if(list[i] instanceof OclPropCall){
	  			list[i] = auxSubst(list[i].toString(),vars[j].toString(),arr);
	  		}
	  		else if(list[i] instanceof OclListExpr){
	  			auxMethod((OclListExpr)list[i],varList,arr);
	  		}
	  		else if(list[i] instanceof OclBinaryExpression){
	  			list[i] = auxM((OclBinaryExpression)list[i],varList,arr);
	  		}
  		
  		}
	
  	}
  	OclListExpr new_list = new OclListExpr(list,"",""," && ");
  	return new_list;
  }
  private static OclBinaryExpression auxM(OclBinaryExpression binExpr,OclListExpr varList,String arr){
  
	  OclExpression []vars = varList.getCollection();   	
  	
	  for(int i=0;i<vars.length;i++){
	  	
	  	if(binExpr.getRightChild() instanceof OclPropCall){
	  		String s = binExpr.getRightChild().toString();
	  		OclPropCall n = auxSubst(s,vars[i].toString(),arr);
	  		binExpr.setRightChild(n);
	  	}
	  	if(binExpr.getLeftChild() instanceof OclPropCall){
	  		String s = binExpr.getLeftChild().toString();
	  		OclPropCall n = auxSubst(s,vars[i].toString(),arr);
	  		binExpr.setLeftChild(n);
	  	}
	  	if(binExpr.getRightChild() instanceof OclBinaryExpression){
	  		binExpr.setRightChild(auxM((OclBinaryExpression)binExpr.getRightChild(),varList,arr));
	  	}
	  	if(binExpr.getLeftChild() instanceof OclBinaryExpression){
	  		binExpr.setLeftChild(auxM((OclBinaryExpression)binExpr.getLeftChild(),varList,arr));
	  	}
	  	
	  }
	  	
	 return binExpr;
  }
  
  private static OclListExpr auxMethod2(OclListExpr listExpr,String var,String arr){
  	
  	OclExpression[] list = listExpr.getCollection();
  
  	for(int i=0;i<list.length;i++){
  		if(list[i] instanceof OclPropCall){
  			list[i] = auxSubst2(list[i].toString(),var,arr);
  		}
  		else if(list[i] instanceof OclListExpr){
  			auxMethod2((OclListExpr)list[i],var,arr);
  		}
  		else if(list[i] instanceof OclBinaryExpression){
  			list[i] = auxM2((OclBinaryExpression)list[i],var,arr);
  		}
	
  	}
  	OclListExpr new_list = new OclListExpr(list,"",""," && ");
  	return new_list;
  }
  private static OclBinaryExpression auxM2(OclBinaryExpression binExpr,String v,String arr){
  
  	if(binExpr.getRightChild() instanceof OclPropCall){
  		String s = binExpr.getRightChild().toString();
  		OclPropCall n = auxSubst2(s,v,arr);
  		binExpr.setRightChild(n);
  	}
  	if(binExpr.getLeftChild() instanceof OclPropCall){
  		String s = binExpr.getLeftChild().toString();
  		OclPropCall n = auxSubst2(s,v,arr);
  		binExpr.setLeftChild(n);
  	}
  	if(binExpr.getRightChild() instanceof OclBinaryExpression){
  		binExpr.setRightChild(auxM2((OclBinaryExpression)binExpr.getRightChild(),v,arr));
  	}
  	if(binExpr.getLeftChild() instanceof OclBinaryExpression){
  		binExpr.setLeftChild(auxM2((OclBinaryExpression)binExpr.getLeftChild(),v,arr));
  	}
  	
  	return binExpr;
  }
  private static OclPropCall auxSubst(String _testo,String var, String arr){
  
  	if(_testo.equals(var)){
  		return new OclPropCall(new OclName(arr+"["+var+"]"));
  	}
  	else return new OclPropCall(new OclName(_testo));  	
  }

private static OclPropCall auxSubst2(String _testo,String var, String arr){
  
  	if(_testo.equals(var)){
  		return new OclPropCall(new OclName(arr+"[i]"));
  	}
  	else return new OclPropCall(new OclName(_testo));  	
  }
}



